// Choose which assumption you want to make -- f known to be very close to 0.01 
// (select 0)?
// or f not known (1)?
#if (0) 
#define BETA0 0.01
#define BETA1 0.01
// the above values are good for an adaptive encoder that is highly responsive to 
// strings of 0s or 1s.
// - expects the bias of the coin to be from a beta distribn with params 0.01,0.01
// -i.e., can compress files with any bias f=0.01, f=0.1, f=0.9, or f=0.99,
// and especially well-suited to biases such as 0.01 and 0.99
// As the data is read in, the model learns.

#else
// The values below are good when we know a priori that the bias is 0.01
#define BETA0 100000
#define BETA1 1000

#endif
// End choice

// maximum number of bits for a long integer in my program
#define M 30
#define ONE (1<<M)
#define HALF (1<<(M-1))

// minimal permissible gap
#define BMIN (1<<10)   

#define VERBOSE 1
